'use strict';

const _ = require('lodash');
const PubsubTopic = require('./pubsub-topic');

class PubsubManager {

    constructor(options) {
        this.topics = {};

        this.options = _.defaults(options || {}, {
            namespace: null,
            credentials: null,
        });
    }

    /**
     * @param id
     * @returns {PubsubTopic}
     */
    getTopic(id) {
        if(this.options.namespace) {
            id = this.options.namespace + '_' + id;
        }

        if(!(id in this.topics)) {
            this.topics[id] = new PubsubTopic(id, this.options);
        }

        return this.topics[id];
    }
}

PubsubManager.PubsubTopic = PubsubTopic;

module.exports = PubsubManager;